exports.WinstonProbe = WinstonProbe;

function WinstonProbe(agent) {
  this.agent = agent;
  this.packages = ['winston'];
}

WinstonProbe.prototype.init = function () {};

WinstonProbe.prototype.attach = function (obj) {
  if(obj.__appdynamicsProbeAttached__) return;
  obj.__appdynamicsProbeAttached__ = true;
  let self = this;
  self.agent.proxy.before(
    obj.Logger.prototype,
    "write",
    (obj, args) => this.addLifeCycleHooks(obj, args)
  );
};

WinstonProbe.prototype.addLifeCycleHooks = function (obj, args) {
  let self = this;

  if(!self.agent.libagentConnector.getNodeProperty("opentelemetry-logs-push-enabled")
     || !self.agent.OtelLogger) {
    return;
  }

  const threadId =  self.agent.profiler.time().threadId;
  const txn = self.agent.profiler.getTransaction(threadId);
  if(!args[0]) {
    self.agent.logger.debug('Invalid Log message captured in winston probe');
    return;
  }
  const logMessage = args[0];
  this.agent.OtelLogger.emit(txn,
                             self.agent.libagentConnector.getBusinessTransactionId(txn.btGuid),
                             logMessage,
                             self.agent.libagentConnector.filterLogMessage(logMessage.message),
                             self.agent.libagentConnector.getNodeProperty("opentelemetry-allowed-log-level"));
};
